package demo.zusekopf;

import at.gv.zustellung.zkopf.client.BulkQueryClient;
import at.gv.zustellung.zkopf.config.PropertiesZuseKopfConfiguration;
import at.gv.zustellung.zkopf.xsd.zkopf.BulkQueryType;
import at.gv.zustellung.zkopf.xsd.zkopf.MessagingaddressType;
import at.gv.zustellung.zkopf.xsd.zkopf.QueryType;
import at.gv.zustellung.zkopf.xsd.zkopf_persondata.InternetAddressType;
import at.gv.zustellung.zkopf.xsd.zkopf_persondata.PersonNameType;
import at.gv.zustellung.zkopf.xsd.zkopf_persondata.PersonNameType.FamilyName;
import at.gv.zustellung.zkopf.xsd.zkopf_persondata.PhysicalPersonType;

public class DemoBulkQuery {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		
		String bulkQueryServiceURL = "https://zkopf.zustellung.gv.at/services/BulkQuery";
		BulkQueryType query = new BulkQueryType();
		
		// create query with physical person and demographic data
		QueryType q1 = new QueryType();
		q1.setID("0");
		PhysicalPersonType ppt = new PhysicalPersonType();
		PersonNameType pnt = new PersonNameType();
		pnt.setGivenName("Arne");
		FamilyName fnt = new FamilyName();
		fnt.setValue("Tauber");
		pnt.setFamilyName(fnt);
		ppt.setName(pnt);
		ppt.setDateOfBirth("1979-08-21");
		q1.setPhysicalPerson(ppt);
		MessagingaddressType mat = new MessagingaddressType();
		InternetAddressType iat = new InternetAddressType();
		iat.setAddress("arne.tauber@egiz.gv.at");
		mat.setInternetAddress(iat);
		q1.setVerAddress(mat);
		query.getQuery().add(q1);
		
		// create query with gvzbpk
//		QueryType q2 = new QueryType();
//		q2.setID("1");
//		IdentificationType idt = new IdentificationType();
//		idt.setType("urn:publicid:gv.at:ecdid+ZU");
//		Value value = new Value();
//		value.setValue("XYZ");
//		idt.setValue(value);
//		q2.setIdentification(idt);

		// make bulk query
		PropertiesZuseKopfConfiguration propsConfig = new PropertiesZuseKopfConfiguration("sample-conf/zusekopf.properties");
		BulkQueryClient client = new BulkQueryClient(propsConfig);
		client.sendBulkQueryRequest(bulkQueryServiceURL, query);

	}

}
