/*
 * Copyright 2011 E-Government Innovation Center (EGIZ)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package demo.zusemsg;

import java.io.FileInputStream;

import javax.xml.bind.JAXBContext;

import at.gv.zustellung.zusemsg.config.PropertiesZuseMsgConfiguration;
import at.gv.zustellung.zusemsg.config.ZuseMsgConfiguration;
import at.gv.zustellung.zusemsg.wsdl.client.Zuse2AppClient;
import at.gv.zustellung.zusemsg.xsd.zuse.DeliveryNotification;

public class DemoZuse2App {

	/**
	 * @param args
	 */
  public static void main(String[] args) throws Exception {
		
		// load configuration
		ZuseMsgConfiguration config = new PropertiesZuseMsgConfiguration("sample-conf/zusemsg.properties");
		
		// initialize client
		Zuse2AppClient client = new Zuse2AppClient(config, true);
		
		// load notification from file
		JAXBContext ctx = JAXBContext.newInstance(DeliveryNotification.class.getPackage().getName());
		
		// load a sample delivery notification from file
		DeliveryNotification deliveryNotification = (DeliveryNotification) ctx.createUnmarshaller().unmarshal(
				new FileInputStream("sample-requests/zusemsg/Sample_Notification_Success.xml"));
		
		// send delivery notification
		//client.sendDeliveryRequestWebService("http://demo.egiz.gv.at/dumpzs/Dump", deliveryNotification);
		// use webservice
		client.sendDeliveryRequestWebService("http://apps.egiz.gv.at/zuse2app/zuse2app?wsdl", deliveryNotification);
		//client.sendDeliveryRequestWebService("http://localhost:8080/zusespocs/zuse2app", deliveryNotification);
		// use e-mail
		client.sendDeliveryRequestEmail("arne.tauber@egiz.gv.at", deliveryNotification);
		
	}

}
